Function nls_import ()

private _redlinije := 0

use_language()
if reccount() > 0

   if !msgyesno('Data found, are you sure?')
      dbcloseall()
      return
   endif
endif
dbcloseall()

read_dir()

use_language()
zap
reindex
set order to 2

dbappend()
replace line with 0
replace text1 with 'lang1'
replace text2 with 'lang2'

use_temp()
zap

use _files new
delete for ext != 'PRG'
pack

do while .not. eof()

_prg = alltrim(name)
_load = _prg + '.prg'

select temp
zap
append from &_load sdf

dbgotop()
do while .not. eof()

_red = recno()
_lin = alltrim(linija)
_duz = len(_lin)
_pos = 0
_tip = 0

if at(chr(39),_lin) > 0  // aopstrof
    _pos = at(chr(39),_lin)
   _tip = 2
endif

if at(chr(34),_lin) > 0  // navodnik
    _pos = at(chr(34),_lin)
   _tip = 1
endif
  
if _POS > 0

   for i = _pos+1 to _duz
  
      _ch = substr(_lin,i,1)
      if (_tip = 1 .and. _ch = chr(34)) .or. (_tip = 2 .and. _ch = chr(39))
         _name = substr(_lin,_pos+1,i-_pos-1)
         exit
      else
         loop
      endif

   next

   _name = alltrim(_name) 

if _name = '.lng'
altd()
endif
   
   select language
   seek _name
   if !found()
      _redlinije++
      dbappend()
	  replace line  with _redlinije
      replace text1 with _name
      replace text2 with _name
   endif

endif

select temp
dbskip()
enddo

select _files
dbskip()
enddo

dbcloseall()

delete file temp.dbf
delete file _files.dbf

msginfo('Finish')

return
*:----------------------------------------------------------------------
FUNCTION read_dir

LOCAL afiles, list_dbf, jj, act_sel, i, ii, e_name, w_ext, w_name

IF ! FILE ("_files.dbf")
   list_dbf := {}
   AADD(list_dbf,{"name","c",20,0})
   AADD(list_dbf,{"ext","c",3,0})
   DBCREATE("_files",list_dbf)
ENDIF

afiles = DIRECTORY()
jj = LEN(afiles)

IF jj = 0
   RETURN -1
ENDIF

act_sel = SELECT()

SELECT 0
USE _files
ZAP
dbgotop()

FOR i = 1 TO jj
   e_name = afiles[i][1]
   w_ext = ''
   
   ii = AT(".",e_name)
   IF ii = 0
      w_name = e_name
      w_ext  = ''
   ELSE
      w_name = SUBSTR(e_name,1,ii-1)
      w_ext  = SUBSTR(e_name,ii+1,3)
   ENDIF
   
   dbappend()
   REPLACE name WITH upper(w_name)
   REPLACE ext  WITH upper(w_ext)
NEXT

USE

SELECT(act_sel)

RETURN 0
